var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EntityMetadataNotFound } from "../error/EntityMetadataNotFound";
/**
 * Array for the entity metadatas.
 */
var EntityMetadataCollection = (function (_super) {
    __extends(EntityMetadataCollection, _super);
    function EntityMetadataCollection() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    EntityMetadataCollection.prototype.hasTarget = function (target) {
        return !!this.find(function (metadata) { return metadata.target === target || (typeof target === "string" && metadata.targetName === target); });
    };
    EntityMetadataCollection.prototype.findByTarget = function (target) {
        var metadata = this.find(function (metadata) { return metadata.target === target || (typeof target === "string" && metadata.targetName === target); });
        if (!metadata)
            throw new EntityMetadataNotFound(target);
        return metadata;
    };
    EntityMetadataCollection.prototype.findByName = function (name) {
        var metadata = this.find(function (metadata) { return metadata.name === name; });
        if (!metadata)
            throw new EntityMetadataNotFound(name);
        return metadata;
    };
    EntityMetadataCollection.prototype.filter = function (callbackfn, thisArg) {
        thisArg = thisArg || void 0;
        return this.reduce(function (out, val, index, array) {
            if (callbackfn.call(thisArg, val, index, array)) {
                out.push(val);
            }
            return out;
        }, new EntityMetadataCollection());
    };
    return EntityMetadataCollection;
}(Array));
export { EntityMetadataCollection };
//# sourceMappingURL=EntityMetadataCollection.js.map