var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { MetadataAlreadyExistsError } from "../../metadata-builder/error/MetadataAlreadyExistsError";
var TargetMetadataArgsCollection = (function (_super) {
    __extends(TargetMetadataArgsCollection, _super);
    function TargetMetadataArgsCollection() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    TargetMetadataArgsCollection.prototype.filter = function (callbackfn, thisArg) {
        var collection = new this.constructor();
        _super.prototype.filter.call(this, callbackfn)
            .forEach(function (metadata) { return collection.add(metadata); });
        return collection;
    };
    TargetMetadataArgsCollection.prototype.filterByTarget = function (cls) {
        // if no class specified then simply return empty collection
        if (!cls)
            return new this.constructor();
        return this.filterByTargets([cls]);
    };
    TargetMetadataArgsCollection.prototype.filterByTargets = function (classes) {
        return this.filter(function (metadata) {
            if (!metadata.target)
                return false;
            return classes.indexOf(metadata.target) !== -1;
        });
    };
    TargetMetadataArgsCollection.prototype.add = function (metadata, checkForDuplicateTargets) {
        if (checkForDuplicateTargets === void 0) { checkForDuplicateTargets = false; }
        if (checkForDuplicateTargets) {
            if (!metadata.target || !(metadata.target instanceof Function))
                throw new Error("Target is not set in the given metadata.");
            if (this.hasWithTarget(metadata.target))
                throw new MetadataAlreadyExistsError(metadata.constructor.name, metadata.target);
        }
        this.push(metadata);
    };
    // -------------------------------------------------------------------------
    // Private Methods
    // -------------------------------------------------------------------------
    TargetMetadataArgsCollection.prototype.hasWithTarget = function (constructor) {
        return !!this.find(function (metadata) { return metadata.target === constructor; });
    };
    return TargetMetadataArgsCollection;
}(Array));
export { TargetMetadataArgsCollection };
//# sourceMappingURL=TargetMetadataArgsCollection.js.map