import { getFromContainer } from "../../index";
import { RepositoryFactory } from "./RepositoryFactory";
/**
 * Aggregates all repositories of the specific metadata.
 */
var RepositoryAggregator = (function () {
    // -------------------------------------------------------------------------
    // Constructor
    // -------------------------------------------------------------------------
    function RepositoryAggregator(connection, metadata, queryRunnerProvider) {
        var repositoryFactory = getFromContainer(RepositoryFactory);
        this.metadata = metadata;
        if (metadata.table.isClosure) {
            this.repository = this.treeRepository = repositoryFactory.createTreeRepository(connection, metadata, queryRunnerProvider);
        }
        else {
            this.repository = repositoryFactory.createRepository(connection, metadata, queryRunnerProvider);
        }
        this.specificRepository = repositoryFactory.createSpecificRepository(connection, metadata, this.repository, queryRunnerProvider);
    }
    return RepositoryAggregator;
}());
export { RepositoryAggregator };
//# sourceMappingURL=RepositoryAggregator.js.map