import { TreeRepository } from "./TreeRepository";
import { Repository } from "./Repository";
import { SpecificRepository } from "./SpecificRepository";
/**
 * Factory used to create different types of repositories.
 */
var RepositoryFactory = (function () {
    function RepositoryFactory() {
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    /**
     * Creates a regular repository.
     */
    RepositoryFactory.prototype.createRepository = function (connection, metadata, queryRunnerProvider) {
        return new Repository(connection, metadata, queryRunnerProvider);
    };
    /**
     * Creates a tree repository.
     */
    RepositoryFactory.prototype.createTreeRepository = function (connection, metadata, queryRunnerProvider) {
        return new TreeRepository(connection, metadata, queryRunnerProvider);
    };
    /**
     * Creates a specific repository.
     */
    RepositoryFactory.prototype.createSpecificRepository = function (connection, metadata, repository, queryRunnerProvider) {
        return new SpecificRepository(connection, metadata, repository, queryRunnerProvider);
    };
    return RepositoryFactory;
}());
export { RepositoryFactory };
//# sourceMappingURL=RepositoryFactory.js.map